Skip to main content
`Ctrl`+`K`

# pandas.DataFrame.infer_objects

DataFrame.infer_objects(copy=None)

  Attempt to infer better dtypes for object columns.

  Attempts soft conversion of object-dtyped columns, leaving non-object and unconvertible columns unchanged. The inference rules are the same as during normal Series/DataFrame construction.

  Parameters:
    copy bool, default True

      Whether to make a copy for non-object or non-inferable columns or Series.

      Note

      The copy keyword will change behavior in pandas 3.0. Copy-on-Write will be enabled by default, which means that all methods with a copy keyword will use a lazy copy mechanism to defer the copy and ignore the copy keyword. The copy keyword will be removed in a future version of pandas.

      You can already get the future behavior and improvements through enabling copy on write `pd.options.mode.copy_on_write = True`

  Returns:
    same type as input object

  See also

  `to_datetime`

    Convert argument to datetime.

  `to_timedelta`

    Convert argument to timedelta.

  `to_numeric`

    Convert argument to numeric type.

  `convert_dtypes`

    Convert argument to best possible dtype.

  Examples

      >>> df = pd.DataFrame({"A": ["a", 1, 2, 3]})
      >>> df = df.iloc[1:]
      >>> df
         A
      1  1
      2  2
      3  3

      >>> df.dtypes
      A    object
      dtype: object

      >>> df.infer_objects().dtypes
      A    int64
      dtype: object